import * as i0 from '@angular/core';
import { EventEmitter, Component, Input, Output, Inject, NgModule, Injectable, Optional, SkipSelf, Pipe, ViewChild } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i5 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i3 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i4 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i1$1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import * as i6 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i7 from '@angular/material/progress-bar';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import * as i9 from '@angular/material/progress-spinner';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatSelectModule } from '@angular/material/select';
import * as i4$1 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i5$1 from '@angular/material/form-field';
import { JwtHelperService } from '@auth0/angular-jwt';
import * as i2 from '@angular/common/http';
import { HttpRequest, HttpHeaders, HttpEventType, HttpResponse, HttpClientModule } from '@angular/common/http';
import { of, Subject, forkJoin } from 'rxjs';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import * as i5$2 from '@angular/material/list';
import { MatListModule } from '@angular/material/list';
import * as i6$1 from '@angular/material/core';
import * as i1$2 from '@angular/platform-browser';

var ConfirmationDialogMode;
(function (ConfirmationDialogMode) {
    ConfirmationDialogMode[ConfirmationDialogMode["OkCancel"] = 0] = "OkCancel";
    ConfirmationDialogMode[ConfirmationDialogMode["YesNo"] = 1] = "YesNo";
    ConfirmationDialogMode[ConfirmationDialogMode["TrueFalse"] = 2] = "TrueFalse";
    ConfirmationDialogMode[ConfirmationDialogMode["Custom"] = 3] = "Custom";
})(ConfirmationDialogMode || (ConfirmationDialogMode = {}));

class DialogComponent {
    constructor() {
        this.closed = new EventEmitter();
        this.ConfirmationDialogMode = ConfirmationDialogMode;
        this.mode = ConfirmationDialogMode.OkCancel;
        this.customTrueFalseText = null;
    }
    ngOnInit() {
        if (this.data) {
            this.title = this.data.title || null;
            this.message = this.data.message || null;
            this.checkboxMessage = this.data.checkboxMessage || null;
            this.placeholder = this.data.placeholder || null;
            this.userInput = this.data.value || null;
            this.mode = this.data.mode || ConfirmationDialogMode.OkCancel;
            this.customTrueFalseText = this.data.customTrueFalseText;
        }
    }
    close() {
        let data;
        switch (this.dialogType) {
            case 'message':
                data = this.checkboxMessage ?
                    {
                        checkbox: this.checkboxValue || false
                    } :
                    null;
                break;
            case 'input':
                data = this.checkboxMessage ?
                    {
                        response: this.userInput,
                        checkbox: this.checkboxValue || false
                    } :
                    this.userInput;
                break;
            case 'confirmation':
                data = this.checkboxMessage ?
                    {
                        response: true,
                        checkbox: this.checkboxValue || false
                    } :
                    true;
                break;
        }
        this.closed.emit(data);
    }
    cancel() {
        let data;
        if (this.dialogType === 'confirmation') {
            data = this.checkboxMessage ?
                {
                    response: false,
                    checkbox: this.checkboxValue || false
                } :
                false;
        }
        this.closed.emit(data);
    }
}
DialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: DialogComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.3", type: DialogComponent, selector: "cp-dialog", inputs: { dialogType: "dialogType", data: "data" }, outputs: { closed: "closed" }, ngImport: i0, template: "<h2 *ngIf=\"title\" mat-dialog-title [innerHTML]=\"title\"></h2>\r\n\r\n<mat-dialog-content>\r\n    <div *ngIf=\"message\" [innerHTML]=\"message\"></div>\r\n\r\n    <mat-form-field *ngIf=\"dialogType === 'input'\">\r\n        <textarea matInput [placeholder]=\"placeholder\" [(ngModel)]=\"userInput\"></textarea>\r\n    </mat-form-field>\r\n\r\n    <div id=\"checkbox\" *ngIf=\"checkboxMessage\">\r\n        <mat-checkbox [(ngModel)]=\"checkboxValue\">\r\n            <span [innerHTML]=\"checkboxMessage\"></span>\r\n        </mat-checkbox>\r\n    </div>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions>\r\n    <button mat-raised-button (click)=\"close()\" [disabled]=\"dialogType === 'input' && !userInput\">\r\n        <span [ngSwitch]=\"mode\">\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.YesNo\">Yes</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.TrueFalse\">True</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.Custom\">{{ customTrueFalseText[0] }}</span>\r\n            <span *ngSwitchDefault>OK</span>\r\n        </span>\r\n    </button>\r\n    <button *ngIf=\"dialogType !== 'message'\" mat-raised-button (click)=\"cancel()\">\r\n        <span [ngSwitch]=\"mode\">\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.YesNo\">No</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.TrueFalse\">False</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.Custom\">{{ customTrueFalseText[1] }}</span>\r\n            <span *ngSwitchDefault>Cancel</span>\r\n        </span>\r\n    </button>\r\n</mat-dialog-actions>", styles: ["mat-form-field{margin-top:2em;width:100%}#checkbox{margin:2em 0}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i1.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "directive", type: i5.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i4.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex"], exportAs: ["matCheckbox"] }, { kind: "component", type: i5$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i6.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "directive", type: i1$1.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i1$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i1$1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: DialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cp-dialog', template: "<h2 *ngIf=\"title\" mat-dialog-title [innerHTML]=\"title\"></h2>\r\n\r\n<mat-dialog-content>\r\n    <div *ngIf=\"message\" [innerHTML]=\"message\"></div>\r\n\r\n    <mat-form-field *ngIf=\"dialogType === 'input'\">\r\n        <textarea matInput [placeholder]=\"placeholder\" [(ngModel)]=\"userInput\"></textarea>\r\n    </mat-form-field>\r\n\r\n    <div id=\"checkbox\" *ngIf=\"checkboxMessage\">\r\n        <mat-checkbox [(ngModel)]=\"checkboxValue\">\r\n            <span [innerHTML]=\"checkboxMessage\"></span>\r\n        </mat-checkbox>\r\n    </div>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions>\r\n    <button mat-raised-button (click)=\"close()\" [disabled]=\"dialogType === 'input' && !userInput\">\r\n        <span [ngSwitch]=\"mode\">\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.YesNo\">Yes</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.TrueFalse\">True</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.Custom\">{{ customTrueFalseText[0] }}</span>\r\n            <span *ngSwitchDefault>OK</span>\r\n        </span>\r\n    </button>\r\n    <button *ngIf=\"dialogType !== 'message'\" mat-raised-button (click)=\"cancel()\">\r\n        <span [ngSwitch]=\"mode\">\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.YesNo\">No</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.TrueFalse\">False</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.Custom\">{{ customTrueFalseText[1] }}</span>\r\n            <span *ngSwitchDefault>Cancel</span>\r\n        </span>\r\n    </button>\r\n</mat-dialog-actions>", styles: ["mat-form-field{margin-top:2em;width:100%}#checkbox{margin:2em 0}\n"] }]
        }], propDecorators: { dialogType: [{
                type: Input
            }], data: [{
                type: Input
            }], closed: [{
                type: Output
            }] } });

class ConfirmationDialogComponent {
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
}
ConfirmationDialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: ConfirmationDialogComponent, deps: [{ token: i1$1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
ConfirmationDialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.3", type: ConfirmationDialogComponent, selector: "cp-confirmation-dialog", ngImport: i0, template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'confirmation'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>", dependencies: [{ kind: "component", type: DialogComponent, selector: "cp-dialog", inputs: ["dialogType", "data"], outputs: ["closed"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: ConfirmationDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cp-confirmation-dialog', template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'confirmation'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>" }]
        }], ctorParameters: function () {
        return [{ type: i1$1.MatDialogRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }];
    } });

class InputDialogComponent {
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
}
InputDialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: InputDialogComponent, deps: [{ token: i1$1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
InputDialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.3", type: InputDialogComponent, selector: "cp-input-dialog", ngImport: i0, template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'input'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>", dependencies: [{ kind: "component", type: DialogComponent, selector: "cp-dialog", inputs: ["dialogType", "data"], outputs: ["closed"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: InputDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cp-input-dialog', template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'input'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>" }]
        }], ctorParameters: function () {
        return [{ type: i1$1.MatDialogRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }];
    } });

class MessageDialogComponent {
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
}
MessageDialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: MessageDialogComponent, deps: [{ token: i1$1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
MessageDialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.3", type: MessageDialogComponent, selector: "cp-message-dialog", ngImport: i0, template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'message'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>", dependencies: [{ kind: "component", type: DialogComponent, selector: "cp-dialog", inputs: ["dialogType", "data"], outputs: ["closed"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: MessageDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cp-message-dialog', template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'message'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>" }]
        }], ctorParameters: function () {
        return [{ type: i1$1.MatDialogRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }];
    } });

//#region Imports
//#endregion
class DialogModule {
}
DialogModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: DialogModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DialogModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: DialogModule, declarations: [DialogComponent,
        ConfirmationDialogComponent,
        InputDialogComponent,
        MessageDialogComponent], imports: [CommonModule,
        FormsModule,
        MatButtonModule,
        MatCheckboxModule,
        MatInputModule,
        MatDialogModule], exports: [ConfirmationDialogComponent,
        InputDialogComponent,
        MessageDialogComponent] });
DialogModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: DialogModule, imports: [CommonModule,
        FormsModule,
        MatButtonModule,
        MatCheckboxModule,
        MatInputModule,
        MatDialogModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: DialogModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatCheckboxModule,
                        MatInputModule,
                        MatDialogModule
                    ],
                    declarations: [
                        DialogComponent,
                        ConfirmationDialogComponent,
                        InputDialogComponent,
                        MessageDialogComponent
                    ],
                    exports: [
                        ConfirmationDialogComponent,
                        InputDialogComponent,
                        MessageDialogComponent
                    ],
                    entryComponents: [
                        ConfirmationDialogComponent,
                        InputDialogComponent,
                        MessageDialogComponent
                    ]
                }]
        }] });

class AuthenticationServiceConfig {
}

class SharePointServiceConfig {
}

//#region Imports
//#endregion
class SharePointService {
    //#endregion
    constructor(config, http) {
        this.config = config;
        this.http = http;
    }
    //#region Utilities
    getListItems(list) {
        return this.http.post(this.config.sharePointApiUrl, list);
    }
    getListItemsSimple(list, view, site, limit) {
        return this.http.get(`${this.config.sharePointApiUrl}/${list}/${view}/${site}/${limit}`);
    }
    getPeople(storePeople) {
        // Do we already have people stored locally?
        if (this.people) {
            return of(this.people);
            // return Observable.of(this.people);
        }
        // Should we store people locally for subsequent calls?
        if (storePeople) {
            this.http.get(`${this.config.sharePointApiUrl}/people`)
                .subscribe(peeps => this.people = peeps);
        }
        return this.http.get(`${this.config.sharePointApiUrl}/people`);
    }
    getPhotos(storePhotos) {
        // Do we already have photos stored locally?
        if (this.photos) {
            return of(this.photos);
            // return Observable.of(this.photos);
        }
        /*const spList: SharePointList = {
          list: 'Employee Thumbnail Photos',
          view: 'All Pictures',
          site: 'https://sharepoint.cleavelandprice.com/DigitalDisplay',
          userName: this.config.userName,
          password: this.config.password
        };*/
        const request = {
            list: 'Employee Thumbnail Photos',
            site: 'https://sharepoint.cleavelandprice.com/DigitalDisplay',
            username: this.config.userName,
            password: this.config.password
        };
        // Should we store photos locally for subsequent calls?
        if (storePhotos) {
            this.http.post(`${this.config.sharePointApiUrl}/listitems`, request)
                .subscribe(photos => this.photos = photos);
        }
        return this.http.post(`${this.config.sharePointApiUrl}/listitems`, request);
    }
    getCustomerVisits() {
        const list = {
            list: 'Customer Visits',
            view: 'All Events',
            userName: this.config.userName,
            password: this.config.password
        };
        return this.http.post(this.config.sharePointApiUrl, list);
    }
}
SharePointService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointService, deps: [{ token: SharePointServiceConfig, optional: true }, { token: i2.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
SharePointService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointService, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: SharePointServiceConfig, decorators: [{
                        type: Optional
                    }] }, { type: i2.HttpClient }];
    } });

//#region Imports
//#endregion
/**
 * Authenticate Active Directory user
 */
class AuthenticationService {
    //#endregion
    //#region Lifecycle
    /**
     * @ignore
     */
    constructor(config, http, sharePointService) {
        this.http = http;
        this.sharePointService = sharePointService;
        this.authenticatedChanged = new EventEmitter();
        this.authenticatingChanged = new EventEmitter();
        /**
         * Flag set to true while the service is attempting to authenticate the user
         */
        this.authenticating = false;
        /**
         * Flag set to true when the user is successfully authenticated
         */
        this.authenticated = false;
        this.authenticationApiUrl = config.authenticationApiUrl;
        this.checkForExistingToken();
    }
    //#endregion
    //#region Utilities
    /**
     * Authenticate the user and store the token in Local Storage
     *
     * @param username AD sAMAccountName
     * @param password
     * @param adminGroup AD group that determines if authenticated user is considered an administrator of the app
     */
    login(username, password, adminGroup) {
        const today = new Date();
        //const expiration = new Date().setFullYear(today.getFullYear() + 10);
        const request = {
            username: username,
            password: password,
            adminGroup: adminGroup,
            //expirationDate: expiration // moment().add(10, 'years').toDate()
        };
        this.authenticating = true;
        this.authenticatingChanged.emit(this.authenticating);
        /*this.http.post<string>(this.authenticationApiUrl, request)
          .subscribe(token => this.validateUser(token),
          err => {
            console.log(err);
            this.authenticating = false;
            this.authenticatingChanged.emit(this.authenticating);
          });*/
        this.http.request('POST', this.authenticationApiUrl, { body: request, responseType: 'text' })
            .subscribe(token => this.validateUser(token), err => {
            console.log('Authentication error', err);
            this.authenticating = false;
            this.authenticatingChanged.emit(this.authenticating);
        });
    }
    /**
     * Logout the user and delete the token from Local Storage
     */
    logout() {
        if (localStorage.getItem('token')) {
            localStorage.removeItem('token');
        }
        this.authenticatedUser = null;
        this.authenticated = false;
        this.authenticatedChanged.emit(false);
    }
    /**
     * @ignore
     */
    validateUser(token) {
        if (!token) {
            return;
        }
        const jwtHelper = new JwtHelperService();
        const decoded = jwtHelper.decodeToken(token);
        if (jwtHelper.isTokenExpired(token)) {
            this.logout();
            return;
        }
        this.authenticatedUser = {
            admin: decoded.role === 'Admin',
            displayName: decoded.displayName,
            accountName: decoded.winaccountname,
            distinguishedName: decoded.distinguishedName,
            employeeNumber: decoded.employeeNumber,
            memberOf: decoded.memberOf
        };
        localStorage.setItem('token', token);
        this.getPhoto();
        this.authenticated = true;
        this.authenticatedChanged.emit(this.authenticated);
        this.authenticating = false;
        this.authenticatingChanged.emit(this.authenticating);
    }
    /**
     * @ignore
     */
    getPhoto() {
        this.sharePointService.getPhotos()
            .subscribe(photos => {
            // The user may have been logged out by the time the photos came back
            if (!this.authenticatedUser || !this.authenticatedUser.employeeNumber) {
                return;
            }
            const photo = photos.find(pic => +pic.ows_EmployeeNumber === +this.authenticatedUser.employeeNumber);
            if (photo) {
                this.authenticatedUser.photoUrl = photo.ows_EncodedAbsUrl;
            }
        });
    }
    /**
     * @ignore
     */
    checkForExistingToken() {
        if (localStorage.getItem('token')) {
            this.validateUser(localStorage.getItem('token'));
        }
    }
}
AuthenticationService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: AuthenticationService, deps: [{ token: AuthenticationServiceConfig, optional: true }, { token: i2.HttpClient }, { token: SharePointService }], target: i0.ɵɵFactoryTarget.Injectable });
AuthenticationService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: AuthenticationService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: AuthenticationService, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: AuthenticationServiceConfig, decorators: [{
                        type: Optional
                    }] }, { type: i2.HttpClient }, { type: SharePointService }];
    }, propDecorators: { authenticatedChanged: [{
                type: Output
            }], authenticatingChanged: [{
                type: Output
            }] } });

class LoginFormComponent {
    constructor(dialogRef, sharePointService, authenticationService, data) {
        this.dialogRef = dialogRef;
        this.sharePointService = sharePointService;
        this.authenticationService = authenticationService;
        this.data = data;
        this.adminGroup = data.adminGroup;
    }
    ngOnInit() {
        this.authenticationService.authenticatedChanged
            .subscribe(authenticated => {
            if (authenticated) {
                this.dialogRef.close();
            }
        });
    }
    authenticate() {
        if (!this.sharePointService || !this.username || !this.password) {
            return;
        }
        this.authenticationService.login(this.username, this.password, this.adminGroup);
    }
}
LoginFormComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: LoginFormComponent, deps: [{ token: i1$1.MatDialogRef }, { token: SharePointService }, { token: AuthenticationService }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
LoginFormComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.3", type: LoginFormComponent, selector: "cp-login-form", ngImport: i0, template: "<h2 mat-dialog-title>\r\n  <span *ngIf=\"!authenticationService.authenticating\">Login</span>\r\n  <span *ngIf=\"authenticationService.authenticating\">Authenticating...</span>\r\n</h2>\r\n\r\n<mat-dialog-content [class.loginError]=\"loginError\">\r\n  <div id=\"spinner\" *ngIf=\"authenticationService.authenticating\">\r\n    <mat-progress-spinner color=\"primary\" mode=\"indeterminate\"></mat-progress-spinner>\r\n  </div>\r\n\r\n  <div *ngIf=\"!authenticationService.authenticating\">\r\n    <div>\r\n      <mat-form-field>\r\n        <input matInput placeholder=\"Username\" [(ngModel)]=\"username\" name=\"username\" required (keyup.enter)=\"authenticate()\">\r\n      </mat-form-field>\r\n    </div>\r\n\r\n    <div>\r\n      <mat-form-field>\r\n        <input matInput type=\"password\" placeholder=\"Password\" [(ngModel)]=\"password\" name=\"password\" required (keyup.enter)=\"authenticate()\">\r\n      </mat-form-field>\r\n    </div>\r\n  </div>\r\n\r\n  <div *ngIf=\"!authenticationService.authenticating && loginError\" class=\"alert alert-danger\">\r\n    Bad username or password\r\n  </div>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions *ngIf=\"!authenticationService.authenticating\">\r\n  <button type=\"button\" mat-raised-button (click)=\"authenticate()\">OK</button>\r\n  <button type=\"button\" mat-button (click)=\"dialogRef.close()\">Cancel</button>\r\n</mat-dialog-actions>", styles: ["#spinner{width:100%;height:100%;display:flex;justify-content:center;align-items:center}mat-dialog-content{height:150px}mat-dialog-content.loginError{height:200px}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i5.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i5.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "directive", type: i1$1.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i1$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i1$1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "component", type: i5$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i6.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i9.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "diameter", "strokeWidth", "mode", "value"], exportAs: ["matProgressSpinner"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: LoginFormComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cp-login-form', template: "<h2 mat-dialog-title>\r\n  <span *ngIf=\"!authenticationService.authenticating\">Login</span>\r\n  <span *ngIf=\"authenticationService.authenticating\">Authenticating...</span>\r\n</h2>\r\n\r\n<mat-dialog-content [class.loginError]=\"loginError\">\r\n  <div id=\"spinner\" *ngIf=\"authenticationService.authenticating\">\r\n    <mat-progress-spinner color=\"primary\" mode=\"indeterminate\"></mat-progress-spinner>\r\n  </div>\r\n\r\n  <div *ngIf=\"!authenticationService.authenticating\">\r\n    <div>\r\n      <mat-form-field>\r\n        <input matInput placeholder=\"Username\" [(ngModel)]=\"username\" name=\"username\" required (keyup.enter)=\"authenticate()\">\r\n      </mat-form-field>\r\n    </div>\r\n\r\n    <div>\r\n      <mat-form-field>\r\n        <input matInput type=\"password\" placeholder=\"Password\" [(ngModel)]=\"password\" name=\"password\" required (keyup.enter)=\"authenticate()\">\r\n      </mat-form-field>\r\n    </div>\r\n  </div>\r\n\r\n  <div *ngIf=\"!authenticationService.authenticating && loginError\" class=\"alert alert-danger\">\r\n    Bad username or password\r\n  </div>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions *ngIf=\"!authenticationService.authenticating\">\r\n  <button type=\"button\" mat-raised-button (click)=\"authenticate()\">OK</button>\r\n  <button type=\"button\" mat-button (click)=\"dialogRef.close()\">Cancel</button>\r\n</mat-dialog-actions>", styles: ["#spinner{width:100%;height:100%;display:flex;justify-content:center;align-items:center}mat-dialog-content{height:150px}mat-dialog-content.loginError{height:200px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i1$1.MatDialogRef }, { type: SharePointService }, { type: AuthenticationService }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }];
    } });

class LoginComponent {
    constructor(dialog, authenticationService) {
        this.dialog = dialog;
        this.authenticationService = authenticationService;
    }
    ngOnInit() {
    }
    login() {
        this.dialog.open(LoginFormComponent, {
            data: { adminGroup: this.adminGroup }
        });
    }
    confirmLogout() {
        const dialogRef = this.dialog.open(ConfirmationDialogComponent, {
            data: { message: `Are you sure you want to logout?` }
        });
        dialogRef.afterClosed().subscribe(result => {
            if (result) {
                this.authenticationService.logout();
            }
        });
    }
}
LoginComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: LoginComponent, deps: [{ token: i1$1.MatDialog }, { token: AuthenticationService }], target: i0.ɵɵFactoryTarget.Component });
LoginComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.3", type: LoginComponent, selector: "cp-login", inputs: { adminGroup: "adminGroup" }, ngImport: i0, template: "<div id=\"user-id\">\r\n  <i id=\"unauthenticated-user-image\" *ngIf=\"!authenticationService.authenticated\"\r\n    class=\"fa fa-user-circle\"\r\n    [class.fa-spin]=\"authenticationService.authenticating\"\r\n    aria-hidden=\"true\"\r\n    matTooltip=\"Login\"\r\n    (click)=\"login()\"></i>\r\n\r\n  <img id=\"authenticated-user-image\"\r\n    *ngIf=\"authenticationService.authenticated && authenticationService.authenticatedUser.photoUrl\"\r\n    [src]=\"authenticationService.authenticatedUser.photoUrl\"\r\n    matTooltip=\"Logout\"\r\n    (click)=\"confirmLogout()\" />\r\n\r\n  <i id=\"authenticated-user-image\"\r\n    *ngIf=\"authenticationService.authenticated && !authenticationService.authenticatedUser.photoUrl\"\r\n    class=\"fa fa-user-circle\"\r\n    matTooltip=\"Logout\"\r\n    (click)=\"confirmLogout()\"></i>\r\n\r\n  <div id=\"user-name\" *ngIf=\"authenticationService.authenticated\">\r\n    {{ authenticationService.authenticatedUser.displayName }}\r\n  </div>\r\n</div>", styles: ["#user-id{display:flex;height:2em;padding:.3em;font-family:Verdana,Geneva,Tahoma,sans-serif}.fa{font-size:2em}img{border-radius:100%;width:2em;height:2em}#user-id>div{display:flex;align-items:center;height:100%;margin-left:.75em;font-size:1.15em}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i4$1.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: LoginComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cp-login', template: "<div id=\"user-id\">\r\n  <i id=\"unauthenticated-user-image\" *ngIf=\"!authenticationService.authenticated\"\r\n    class=\"fa fa-user-circle\"\r\n    [class.fa-spin]=\"authenticationService.authenticating\"\r\n    aria-hidden=\"true\"\r\n    matTooltip=\"Login\"\r\n    (click)=\"login()\"></i>\r\n\r\n  <img id=\"authenticated-user-image\"\r\n    *ngIf=\"authenticationService.authenticated && authenticationService.authenticatedUser.photoUrl\"\r\n    [src]=\"authenticationService.authenticatedUser.photoUrl\"\r\n    matTooltip=\"Logout\"\r\n    (click)=\"confirmLogout()\" />\r\n\r\n  <i id=\"authenticated-user-image\"\r\n    *ngIf=\"authenticationService.authenticated && !authenticationService.authenticatedUser.photoUrl\"\r\n    class=\"fa fa-user-circle\"\r\n    matTooltip=\"Logout\"\r\n    (click)=\"confirmLogout()\"></i>\r\n\r\n  <div id=\"user-name\" *ngIf=\"authenticationService.authenticated\">\r\n    {{ authenticationService.authenticatedUser.displayName }}\r\n  </div>\r\n</div>", styles: ["#user-id{display:flex;height:2em;padding:.3em;font-family:Verdana,Geneva,Tahoma,sans-serif}.fa{font-size:2em}img{border-radius:100%;width:2em;height:2em}#user-id>div{display:flex;align-items:center;height:100%;margin-left:.75em;font-size:1.15em}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.MatDialog }, { type: AuthenticationService }]; }, propDecorators: { adminGroup: [{
                type: Input
            }] } });

//#region Imports
//#endregion
/**
 * Provides a component and a service that allows you to perform Active/Directory authentication
 */
class AuthenticationModule {
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('AuthenticationModule is already loaded. Import it in the AppModule only');
        }
    }
    static forRoot(authenticationConfig) {
        return {
            ngModule: AuthenticationModule,
            providers: [
                AuthenticationService,
                { provide: AuthenticationServiceConfig, useValue: authenticationConfig }
            ]
        };
    }
}
AuthenticationModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: AuthenticationModule, deps: [{ token: AuthenticationModule, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.NgModule });
AuthenticationModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: AuthenticationModule, declarations: [LoginComponent,
        LoginFormComponent], imports: [CommonModule,
        FormsModule,
        MatButtonModule,
        MatCheckboxModule,
        MatDialogModule,
        MatInputModule,
        MatProgressBarModule,
        MatProgressSpinnerModule,
        MatTooltipModule,
        MatSelectModule,
        DialogModule], exports: [LoginComponent,
        LoginFormComponent] });
AuthenticationModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: AuthenticationModule, imports: [CommonModule,
        FormsModule,
        MatButtonModule,
        MatCheckboxModule,
        MatDialogModule,
        MatInputModule,
        MatProgressBarModule,
        MatProgressSpinnerModule,
        MatTooltipModule,
        MatSelectModule,
        DialogModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: AuthenticationModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatCheckboxModule,
                        MatDialogModule,
                        MatInputModule,
                        MatProgressBarModule,
                        MatProgressSpinnerModule,
                        MatTooltipModule,
                        MatSelectModule,
                        DialogModule
                    ],
                    declarations: [
                        LoginComponent,
                        LoginFormComponent
                    ],
                    exports: [
                        LoginComponent,
                        LoginFormComponent
                    ],
                    providers: [],
                    entryComponents: [
                        LoginFormComponent
                    ]
                }]
        }], ctorParameters: function () {
        return [{ type: AuthenticationModule, decorators: [{
                        type: Optional
                    }, {
                        type: SkipSelf
                    }] }];
    } });

class EmailServiceConfig {
}

//#region Imports
//#endregion
class EmailService {
    constructor(config, http) {
        this.http = http;
        this.emailServiceConfig = config;
    }
    send(email) {
        const dto = {
            server: this.emailServiceConfig.server,
            smtpPort: this.emailServiceConfig.smtpPort,
            sender: this.emailServiceConfig.sender,
            subject: email.subject,
            content: email.content,
            recipients: email.recipients
        };
        return this.http.post(this.emailServiceConfig.emailApiUrl, dto);
    }
}
EmailService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmailService, deps: [{ token: EmailServiceConfig, optional: true }, { token: i2.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
EmailService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmailService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmailService, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: EmailServiceConfig, decorators: [{
                        type: Optional
                    }] }, { type: i2.HttpClient }];
    } });

//#region Imports
//#endregion
class EmailModule {
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('EmailModule is already loaded. Import it in the AppModule only');
        }
    }
    static forRoot(emailConfig) {
        return {
            ngModule: EmailModule,
            providers: [
                EmailService,
                { provide: EmailServiceConfig, useValue: emailConfig }
            ]
        };
    }
}
EmailModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmailModule, deps: [{ token: EmailModule, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.NgModule });
EmailModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: EmailModule, imports: [CommonModule] });
EmailModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmailModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmailModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [],
                    exports: []
                }]
        }], ctorParameters: function () {
        return [{ type: EmailModule, decorators: [{
                        type: Optional
                    }, {
                        type: SkipSelf
                    }] }];
    } });

class EmployeeServiceConfig {
}

//#region Imports
//#endregion
class EmployeeService {
    //#endregion
    //#region Lifecycle
    constructor(config, http) {
        this.http = http;
        this.employeeApiUrl = config.employeeApiUrl;
    }
    //#endregion
    //#region Utilities
    getEmployees(storeEmployees = false, includeDisabled = false) {
        // Do we already have employees stored locally?
        if (this.employees) {
            return of(this.employees);
            // return Observable.of(this.employees);
        }
        // Should we store employees locally for subsequent calls?
        if (storeEmployees) {
            this.http.get(`${this.employeeApiUrl}/false/${includeDisabled}`)
                .subscribe(emps => this.employees = emps);
        }
        return this.http.get(`${this.employeeApiUrl}/false/${includeDisabled}`);
    }
    getEmployee(sAMAccountName) {
        return this.http.get(`${this.employeeApiUrl}/name/${sAMAccountName}`);
    }
}
EmployeeService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeeService, deps: [{ token: EmployeeServiceConfig, optional: true }, { token: i2.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
EmployeeService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeeService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeeService, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: EmployeeServiceConfig, decorators: [{
                        type: Optional
                    }] }, { type: i2.HttpClient }];
    } });

class DepartmentsPipe {
    transform(employees, args) {
        const departments = [];
        employees
            .filter(emp => emp.department)
            .forEach(emp => {
            if (departments.indexOf(emp.department) === -1) {
                departments.push(emp.department);
            }
        });
        return departments.sort();
    }
}
DepartmentsPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: DepartmentsPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
DepartmentsPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: DepartmentsPipe, name: "departments" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: DepartmentsPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'departments'
                }]
        }] });

class EmployeeByDnPipe {
    transform(employees, dn) {
        return employees
            .find(emp => emp.distinguishedName.toLowerCase() === dn.toLowerCase());
    }
}
EmployeeByDnPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeeByDnPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
EmployeeByDnPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: EmployeeByDnPipe, name: "employeeByDn" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeeByDnPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'employeeByDn'
                }]
        }] });

class EmployeePhotoUrlPipe {
    transform(employee, photos) {
        if (!photos) {
            return null;
        }
        // Try to match by employeeNumber, accountName, or title
        const photo = photos
            .find(pic => (pic.ows_EmployeeNumber && employee.employeeNumber && +pic.ows_EmployeeNumber === +employee.employeeNumber) ||
            (pic.ows_AccountName && pic.ows_AccountName.toLowerCase() === employee.sAMAccountName.toLowerCase()) ||
            (pic.ows_Title && pic.ows_Title.toLowerCase() === employee.displayName.toLowerCase()));
        if (!photo) {
            console.log(`No photo match for ${employee.displayName}`);
        }
        return photo ? photo.ows_EncodedAbsUrl : null;
    }
}
EmployeePhotoUrlPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeePhotoUrlPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
EmployeePhotoUrlPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: EmployeePhotoUrlPipe, name: "employeePhotoUrl" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeePhotoUrlPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'employeePhotoUrl'
                }]
        }] });

class EmployeesWithPropertyValuePipe {
    transform(employees, propertyName, propertyValue) {
        return employees
            .filter(emp => emp[propertyName] && emp[propertyName] === propertyValue);
    }
}
EmployeesWithPropertyValuePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeesWithPropertyValuePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
EmployeesWithPropertyValuePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: EmployeesWithPropertyValuePipe, name: "employeesWithPropertyValue" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeesWithPropertyValuePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'employeesWithPropertyValue'
                }]
        }] });

class FilterEmployeesPipe {
    transform(employees, filter) {
        return filter ?
            employees
                .filter(emp => emp.displayName.toLowerCase().indexOf(filter.toLowerCase()) !== -1 ||
                (emp.department && emp.department.toLowerCase().indexOf(filter.toLowerCase()) !== -1) ||
                (emp.title && emp.title.toLowerCase().indexOf(filter.toLowerCase()) !== -1) ||
                emp.sAMAccountName.toLowerCase().indexOf(filter.toLowerCase()) !== -1) :
            employees;
    }
}
FilterEmployeesPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: FilterEmployeesPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
FilterEmployeesPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: FilterEmployeesPipe, name: "filterEmployees" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: FilterEmployeesPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'filterEmployees'
                }]
        }] });

class IsMemberOfPipe {
    transform(employee, groupName) {
        return employee.memberOf &&
            (employee.memberOf.find(m => m.toLowerCase().indexOf(groupName.toLowerCase()) !== -1) !== undefined);
    }
}
IsMemberOfPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: IsMemberOfPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
IsMemberOfPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: IsMemberOfPipe, name: "isMemberOf" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: IsMemberOfPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'isMemberOf'
                }]
        }] });

class SortEmployeesPipe {
    transform(employees, sortBy, dataType, reverse) {
        return this.getSorted(employees, sortBy ? sortBy : 'displayName', dataType ? dataType : 'string', reverse ? reverse : false);
    }
    getSorted(employees, sortBy, dataType, reverse) {
        const sorted = employees
            .sort((a, b) => {
            let valA, valB;
            switch (dataType.toLowerCase()) {
                case 'string':
                    valA = a[sortBy] ? a[sortBy].toString().toLowerCase() : null;
                    valB = b[sortBy] ? b[sortBy].toString().toLowerCase() : null;
                    break;
                case 'number':
                    valA = a[sortBy] ? +a[sortBy] : null;
                    valB = b[sortBy] ? +b[sortBy] : null;
                    break;
                case 'date':
                    valA = a[sortBy] ? a[sortBy] : null;
                    valB = b[sortBy] ? b[sortBy] : null;
                    break;
            }
            if (valA < valB) {
                return -1;
            }
            if (valA > valB) {
                return 1;
            }
            return 0;
        });
        return reverse ? sorted.reverse() : sorted;
    }
}
SortEmployeesPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SortEmployeesPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
SortEmployeesPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: SortEmployeesPipe, name: "sortEmployees" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SortEmployeesPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'sortEmployees'
                }]
        }] });

//#region Imports
//#endregion
class EmployeeModule {
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('EmployeeModule is already loaded. Import it in the AppModule only');
        }
    }
    static forRoot(employeeConfig) {
        return {
            ngModule: EmployeeModule,
            providers: [
                EmployeeService,
                { provide: EmployeeServiceConfig, useValue: employeeConfig }
            ]
        };
    }
}
EmployeeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeeModule, deps: [{ token: EmployeeModule, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.NgModule });
EmployeeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: EmployeeModule, declarations: [DepartmentsPipe,
        EmployeeByDnPipe,
        EmployeesWithPropertyValuePipe,
        FilterEmployeesPipe,
        IsMemberOfPipe,
        EmployeePhotoUrlPipe,
        SortEmployeesPipe], imports: [CommonModule], exports: [DepartmentsPipe,
        EmployeeByDnPipe,
        EmployeesWithPropertyValuePipe,
        FilterEmployeesPipe,
        IsMemberOfPipe,
        EmployeePhotoUrlPipe,
        SortEmployeesPipe] });
EmployeeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeeModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: EmployeeModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [
                        DepartmentsPipe,
                        EmployeeByDnPipe,
                        EmployeesWithPropertyValuePipe,
                        FilterEmployeesPipe,
                        IsMemberOfPipe,
                        EmployeePhotoUrlPipe,
                        SortEmployeesPipe
                    ],
                    exports: [
                        DepartmentsPipe,
                        EmployeeByDnPipe,
                        EmployeesWithPropertyValuePipe,
                        FilterEmployeesPipe,
                        IsMemberOfPipe,
                        EmployeePhotoUrlPipe,
                        SortEmployeesPipe
                    ]
                }]
        }], ctorParameters: function () {
        return [{ type: EmployeeModule, decorators: [{
                        type: Optional
                    }, {
                        type: SkipSelf
                    }] }];
    } });

class SharePointPhotoUrlPipe {
    transform(photo) {
        return photo.ows_EncodedAbsUrl;
    }
}
SharePointPhotoUrlPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointPhotoUrlPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
SharePointPhotoUrlPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: SharePointPhotoUrlPipe, name: "sharePointPhotoUrl" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointPhotoUrlPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'sharePointPhotoUrl'
                }]
        }] });

class SharePointUrlPipe {
    transform(url) {
        return url !== null ? url.split(',')[0] : null;
    }
}
SharePointUrlPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointUrlPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
SharePointUrlPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: SharePointUrlPipe, name: "sharePointUrl" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointUrlPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'sharePointUrl'
                }]
        }] });

//#region Imports
//#endregion
class SharePointModule {
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('SharePointModule is already loaded. Import it in the AppModule only');
        }
    }
    static forRoot(sharePointConfig) {
        return {
            ngModule: SharePointModule,
            providers: [
                SharePointService,
                { provide: SharePointServiceConfig, useValue: sharePointConfig }
            ]
        };
    }
}
SharePointModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointModule, deps: [{ token: SharePointModule, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.NgModule });
SharePointModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: SharePointModule, declarations: [SharePointPhotoUrlPipe,
        SharePointUrlPipe], imports: [CommonModule], exports: [SharePointPhotoUrlPipe,
        SharePointUrlPipe] });
SharePointModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SharePointModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [
                        SharePointPhotoUrlPipe,
                        SharePointUrlPipe
                    ],
                    exports: [
                        SharePointPhotoUrlPipe,
                        SharePointUrlPipe
                    ]
                }]
        }], ctorParameters: function () {
        return [{ type: SharePointModule, decorators: [{
                        type: Optional
                    }, {
                        type: SkipSelf
                    }] }];
    } });

class UploadServiceConfig {
}

// https://malcoded.com/posts/angular-file-upload-component-with-express
class UploadService {
    constructor(http, config) {
        this.http = http;
        this.uploadApiUrl = config.uploadApiUrl;
        this.uploadPath = config.uploadPath || '';
        this.dbAppId = config.dbAppId || '';
        this.externalReferenceId = config.externalReferenceId || '';
        this.comment = config.comment || '';
        // UI configuration
        this.uploadButtonText = config.uploadButtonText;
        this.uploadDialogTitle = config.uploadDialogTitle;
        this.uploadDialogAddFilesButtonText = config.uploadDialogAddFilesButtonText;
        this.uploadDialogCancelButtonText = config.uploadDialogCancelButtonText;
        this.uploadDialogUploadButtonText = config.uploadDialogUploadButtonText;
        this.uploadDialogFinishButtonText = config.uploadDialogFinishButtonText;
    }
    upload(files) {
        // this will be the our resulting map
        const status = {};
        files.forEach(file => {
            // create a new multipart-form for every file
            const formData = new FormData();
            formData.append('file', file, file.name);
            // create a http-post request and pass the form
            // tell it to report the upload progress
            // A 'Destination' header is used to optionally configure the file upload destination (filesystem)
            // A 'DbAppId' header is used to configure the unique identifier of database uploads
            const req = new HttpRequest('POST', this.uploadApiUrl, formData, {
                reportProgress: true,
                responseType: 'blob',
                headers: new HttpHeaders()
                    .set('Destination', this.uploadPath)
                    .set('DbAppId', this.dbAppId)
                    .set('ExternalReferenceId', this.externalReferenceId)
                    .set('Comment', this.comment)
                /*headers: this.uploadPath ?
                  new HttpHeaders({ 'Destination': this.uploadPath }) :
                  this.dbAppId ?
                    new HttpHeaders({ 'DbAppId': this.dbAppId }) :
                    null*/
            });
            // create a new progress-subject for every file
            const progress = new Subject();
            // send the http-request and subscribe for progress-updates
            this.http.request(req).subscribe(event => {
                if (event.type === HttpEventType.UploadProgress) {
                    // calculate the progress percentage
                    const percentDone = Math.round(100 * event.loaded / event.total);
                    // pass the percentage into the progress-stream
                    progress.next(percentDone);
                }
                else if (event instanceof HttpResponse) {
                    // Close the progress-stream if we get an answer form the API
                    // The upload is complete
                    progress.complete();
                }
            });
            // Save every progress-observable in a map of all observables
            status[file.name] = {
                progress: progress.asObservable()
            };
        });
        // return the map of progress.observables
        return status;
    }
    exists(fileName) {
        const query = this.uploadApiUrl.toLowerCase().indexOf('filesystem') === -1 ?
            { name: fileName, dbAppId: this.dbAppId } :
            { name: fileName, destination: this.uploadPath };
        return this.http.post(`${this.uploadApiUrl}/exists`, query);
    }
    download(request) {
        return this.http.post(`${this.uploadApiUrl}/stream`, request, { responseType: 'blob' });
    }
    getUploadInfo(request) {
        return this.http.post(`${this.uploadApiUrl}/info`, request);
    }
}
UploadService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadService, deps: [{ token: i2.HttpClient }, { token: UploadServiceConfig, optional: true }], target: i0.ɵɵFactoryTarget.Injectable });
UploadService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadService, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: i2.HttpClient }, { type: UploadServiceConfig, decorators: [{
                        type: Optional
                    }] }];
    } });

class UploadDialogComponent {
    constructor(dialogRef, uploadService) {
        this.dialogRef = dialogRef;
        this.uploadService = uploadService;
        this.files = new Set();
        this.canBeClosed = true;
        this.showCancelButton = true;
        this.uploading = false;
        this.uploadSuccessful = false;
    }
    ngOnInit() {
        this.uploadDialogTitle = this.uploadService.uploadDialogTitle ?
            this.uploadService.uploadDialogTitle :
            'Upload Files';
        this.uploadDialogAddFilesButtonText = this.uploadService.uploadDialogAddFilesButtonText ?
            this.uploadService.uploadDialogAddFilesButtonText :
            'Add Files';
        this.uploadDialogCancelButtonText = this.uploadService.uploadDialogCancelButtonText ?
            this.uploadService.uploadDialogCancelButtonText :
            'Cancel';
        this.uploadDialogUploadButtonText = this.uploadService.uploadDialogUploadButtonText ?
            this.uploadService.uploadDialogUploadButtonText :
            'Upload';
        this.uploadDialogFinishButtonText = this.uploadService.uploadDialogFinishButtonText ?
            this.uploadService.uploadDialogFinishButtonText :
            'Finish';
        this.primaryButtonText = this.uploadDialogUploadButtonText;
    }
    addFiles() {
        this.file.nativeElement.click();
    }
    onFilesAdded() {
        const files = this.file.nativeElement.files;
        for (const key in files) {
            if (!isNaN(parseInt(key))) {
                // See if the file already exists
                this.uploadService.exists(files[key].name)
                    .subscribe(exists => {
                    if (exists) {
                        this.existingFileConflict = files[key].name;
                    }
                    if (!exists) {
                        this.files.add(files[key]);
                    }
                });
            }
        }
    }
    closeDialog() {
        // if everything was uploaded already, just close the dialog
        if (this.uploadSuccessful) {
            return this.dialogRef.close();
        }
        // set the component state to "uploading"
        this.uploading = true;
        // start the upload and save the progress map
        this.progress = this.uploadService.upload(this.files);
        // convert the progress map into an array
        const allProgressObservables = [];
        for (let key in this.progress) {
            allProgressObservables.push(this.progress[key].progress);
        }
        // Adjust the state variables
        // The OK-button should have the text "Finish" now
        this.primaryButtonText = this.uploadDialogFinishButtonText;
        // The dialog should not be closed while uploading
        this.canBeClosed = false;
        this.dialogRef.disableClose = true;
        // Hide the cancel-button
        this.showCancelButton = false;
        // When all progress-observables are completed...
        forkJoin(allProgressObservables).subscribe(end => {
            // ... the dialog can be closed again...
            this.canBeClosed = true;
            this.dialogRef.disableClose = false;
            // ... the upload was successful...
            this.uploadSuccessful = true;
            // ... and the component is no longer uploading
            this.uploading = false;
        });
    }
}
UploadDialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadDialogComponent, deps: [{ token: i1$1.MatDialogRef }, { token: UploadService }], target: i0.ɵɵFactoryTarget.Component });
UploadDialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.3", type: UploadDialogComponent, selector: "cp-upload-dialog", viewQueries: [{ propertyName: "file", first: true, predicate: ["file"], descendants: true, static: true }], ngImport: i0, template: "<input type=\"file\" #file style=\"display: none\" (change)=\"onFilesAdded()\" multiple />\r\n\r\n<div mat-dialog-title id=\"title\">\r\n  <div>{{ uploadDialogTitle }}</div>\r\n  <button [disabled]=\"uploading || uploadSuccessful\" mat-raised-button color=\"primary\" class=\"add-files-btn\" (click)=\"addFiles()\">\r\n    {{ uploadDialogAddFilesButtonText }}\r\n  </button>\r\n</div>\r\n\r\n<div id=\"conflict\" *ngIf=\"existingFileConflict\">\r\n  {{ existingFileConflict }} already exists on the server and cannot be overwritten\r\n</div>\r\n\r\n<mat-dialog-content>\r\n  <mat-list>\r\n    <mat-list-item *ngFor=\"let file of files\">\r\n      <h4 mat-line>{{file.name}}</h4>\r\n      <mat-progress-bar *ngIf=\"progress\" mode=\"determinate\" [value]=\"progress[file.name].progress | async\"></mat-progress-bar>\r\n    </mat-list-item>\r\n  </mat-list>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions id=\"actions\">\r\n  <button *ngIf=\"showCancelButton\" mat-button mat-dialog-close>{{ uploadDialogCancelButtonText }}</button>\r\n  <button *ngIf=\"files.size > 0\" mat-raised-button color=\"primary\" [disabled]=\"!canBeClosed\" (click)=\"closeDialog()\">{{ primaryButtonText }}</button>\r\n</mat-dialog-actions>\r\n", styles: ["#title{display:flex;justify-content:space-between}#actions{display:flex;justify-content:flex-end}#conflict{font-size:.8em;color:red;margin-top:.5em}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i3.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "directive", type: i1$1.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }, { kind: "directive", type: i1$1.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i1$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i1$1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "component", type: i5$2.MatList, selector: "mat-list, mat-action-list", inputs: ["disableRipple", "disabled"], exportAs: ["matList"] }, { kind: "component", type: i5$2.MatListItem, selector: "mat-list-item, a[mat-list-item], button[mat-list-item]", inputs: ["disableRipple", "disabled"], exportAs: ["matListItem"] }, { kind: "directive", type: i6$1.MatLine, selector: "[mat-line], [matLine]" }, { kind: "component", type: i7.MatProgressBar, selector: "mat-progress-bar", inputs: ["color", "value", "bufferValue", "mode"], outputs: ["animationEnd"], exportAs: ["matProgressBar"] }, { kind: "pipe", type: i1.AsyncPipe, name: "async" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cp-upload-dialog', template: "<input type=\"file\" #file style=\"display: none\" (change)=\"onFilesAdded()\" multiple />\r\n\r\n<div mat-dialog-title id=\"title\">\r\n  <div>{{ uploadDialogTitle }}</div>\r\n  <button [disabled]=\"uploading || uploadSuccessful\" mat-raised-button color=\"primary\" class=\"add-files-btn\" (click)=\"addFiles()\">\r\n    {{ uploadDialogAddFilesButtonText }}\r\n  </button>\r\n</div>\r\n\r\n<div id=\"conflict\" *ngIf=\"existingFileConflict\">\r\n  {{ existingFileConflict }} already exists on the server and cannot be overwritten\r\n</div>\r\n\r\n<mat-dialog-content>\r\n  <mat-list>\r\n    <mat-list-item *ngFor=\"let file of files\">\r\n      <h4 mat-line>{{file.name}}</h4>\r\n      <mat-progress-bar *ngIf=\"progress\" mode=\"determinate\" [value]=\"progress[file.name].progress | async\"></mat-progress-bar>\r\n    </mat-list-item>\r\n  </mat-list>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions id=\"actions\">\r\n  <button *ngIf=\"showCancelButton\" mat-button mat-dialog-close>{{ uploadDialogCancelButtonText }}</button>\r\n  <button *ngIf=\"files.size > 0\" mat-raised-button color=\"primary\" [disabled]=\"!canBeClosed\" (click)=\"closeDialog()\">{{ primaryButtonText }}</button>\r\n</mat-dialog-actions>\r\n", styles: ["#title{display:flex;justify-content:space-between}#actions{display:flex;justify-content:flex-end}#conflict{font-size:.8em;color:red;margin-top:.5em}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.MatDialogRef }, { type: UploadService }]; }, propDecorators: { file: [{
                type: ViewChild,
                args: ['file', { static: true }]
            }] } });

class UploadComponent {
    constructor(dialog, uploadService) {
        this.dialog = dialog;
        this.uploadService = uploadService;
        this.dialogClosed = new EventEmitter();
    }
    ngOnInit() {
        this.uploadButtonText = this.uploadService.uploadButtonText ?
            this.uploadService.uploadButtonText :
            'Upload';
    }
    openUploadDialog() {
        this.dialog.open(UploadDialogComponent, { width: '50%' })
            .afterClosed().subscribe(() => this.dialogClosed.emit());
    }
}
UploadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadComponent, deps: [{ token: i1$1.MatDialog }, { token: UploadService }], target: i0.ɵɵFactoryTarget.Component });
UploadComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.3", type: UploadComponent, selector: "cp-upload", outputs: { dialogClosed: "dialogClosed" }, ngImport: i0, template: '<button mat-raised-button (click)="openUploadDialog()">{{ uploadButtonText }}</button>', isInline: true, dependencies: [{ kind: "component", type: i3.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'cp-upload',
                    template: '<button mat-raised-button (click)="openUploadDialog()">{{ uploadButtonText }}</button>'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.MatDialog }, { type: UploadService }]; }, propDecorators: { dialogClosed: [{
                type: Output
            }] } });

//#region Imports
//#endregion
class UploadModule {
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('UploadModule is already loaded. Import it in the AppModule only');
        }
    }
    static forRoot(uploadConfig) {
        return {
            ngModule: UploadModule,
            providers: [
                UploadService,
                { provide: UploadServiceConfig, useValue: uploadConfig }
            ]
        };
    }
}
UploadModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadModule, deps: [{ token: UploadModule, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.NgModule });
UploadModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: UploadModule, declarations: [UploadComponent,
        UploadDialogComponent], imports: [CommonModule,
        BrowserAnimationsModule,
        HttpClientModule,
        MatButtonModule,
        MatDialogModule,
        MatListModule,
        MatProgressBarModule], exports: [UploadComponent,
        UploadDialogComponent] });
UploadModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadModule, imports: [CommonModule,
        BrowserAnimationsModule,
        HttpClientModule,
        MatButtonModule,
        MatDialogModule,
        MatListModule,
        MatProgressBarModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UploadModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        BrowserAnimationsModule,
                        HttpClientModule,
                        MatButtonModule,
                        MatDialogModule,
                        MatListModule,
                        MatProgressBarModule
                    ],
                    declarations: [
                        UploadComponent,
                        UploadDialogComponent
                    ],
                    exports: [
                        UploadComponent,
                        UploadDialogComponent
                    ],
                    entryComponents: [
                        UploadDialogComponent
                    ]
                }]
        }], ctorParameters: function () {
        return [{ type: UploadModule, decorators: [{
                        type: Optional
                    }, {
                        type: SkipSelf
                    }] }];
    } });

// This pipe whitelists URLs so that they aren't prefixed with 'unsafe:' when they render in the DOM
class SafeUrlPipe {
    constructor(domSanitizer) {
        this.domSanitizer = domSanitizer;
    }
    transform(value) {
        return this.domSanitizer.bypassSecurityTrustUrl(value);
    }
}
SafeUrlPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SafeUrlPipe, deps: [{ token: i1$2.DomSanitizer }], target: i0.ɵɵFactoryTarget.Pipe });
SafeUrlPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: SafeUrlPipe, name: "safeUrl" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: SafeUrlPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'safeUrl'
                }]
        }], ctorParameters: function () { return [{ type: i1$2.DomSanitizer }]; } });

class UriSchemePipe {
    // https://docs.microsoft.com/en-us/office/client-developer/office-uri-schemes
    transform(value) {
        if (!localStorage.getItem('useUriScheme')) {
            return value;
        }
        const urlSplit = value.split('.');
        const extension = urlSplit[urlSplit.length - 1];
        if (!extension) {
            return value;
        }
        const command = this.command(extension);
        const app = this.app(extension);
        return `ms-${app}:${command}|u|${value}`;
    }
    app(extension) {
        switch (extension.toLowerCase()) {
            // documents
            case 'doc':
            case 'docx':
            case 'docm':
            case 'docb':
            case 'dot':
            case 'dotx':
            case 'dotm': // templates
                return 'word';
            case 'xls':
            case 'xlsx':
            case 'xlm':
            case 'xlsm':
            case 'xlsb':
            case 'xlw':
            case 'xlt':
            case 'xltx':
            case 'xltm': // templates
                return 'excel';
            case 'ppt':
            case 'pptx':
            case 'pps':
            case 'ppsx':
            case 'pptm':
            case 'ppsm':
            case 'sldx':
            case 'sldm':
            case 'pot':
            case 'potx':
            case 'potm': // templates
                return 'powerpoint';
            case 'vsd':
            case 'vsdx':
            case 'vst':
            case 'vstx': // templates
                return 'visio';
            case 'mdb':
            case 'accdb':
            case 'accde':
            case 'accdr':
            case 'accdt': // templates
                return 'access';
            case 'mpp':
            case 'mppx':
            case 'mpt': // templates
                return 'project';
            case 'pub':
                return 'publisher';
            case 'xsn':
                return 'infopath';
        }
    }
    command(extension) {
        switch (extension.toLowerCase()) {
            case 'dot':
            case 'dotx':
            case 'dotm':
            case 'xlt':
            case 'xltx':
            case 'xltm':
            case 'pot':
            case 'potx':
            case 'potm':
            case 'vst':
            case 'vstx':
            case 'accdt':
            case 'mpt':
                return 'nft'; // new from template
            default:
                const openMode = 'v'; // for view, or 'e' or edit
                return `of${openMode}`; // default: open file as view/edit
        }
    }
}
UriSchemePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UriSchemePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
UriSchemePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: UriSchemePipe, name: "uriScheme", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UriSchemePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'uriScheme',
                    pure: false
                }]
        }] });

//#region Imports
//#endregion
class UrlModule {
}
UrlModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UrlModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
UrlModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.3", ngImport: i0, type: UrlModule, declarations: [SafeUrlPipe,
        UriSchemePipe], imports: [CommonModule], exports: [SafeUrlPipe,
        UriSchemePipe] });
UrlModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UrlModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.3", ngImport: i0, type: UrlModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [
                        SafeUrlPipe,
                        UriSchemePipe
                    ],
                    exports: [
                        SafeUrlPipe,
                        UriSchemePipe
                    ],
                    entryComponents: []
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { AuthenticationModule, AuthenticationService, AuthenticationServiceConfig, ConfirmationDialogComponent, ConfirmationDialogMode, DepartmentsPipe, DialogModule, EmailModule, EmailService, EmailServiceConfig, EmployeeByDnPipe, EmployeeModule, EmployeePhotoUrlPipe, EmployeeService, EmployeeServiceConfig, EmployeesWithPropertyValuePipe, FilterEmployeesPipe, InputDialogComponent, IsMemberOfPipe, LoginComponent, LoginFormComponent, MessageDialogComponent, SafeUrlPipe, SharePointModule, SharePointPhotoUrlPipe, SharePointService, SharePointServiceConfig, SharePointUrlPipe, SortEmployeesPipe, UploadComponent, UploadDialogComponent, UploadModule, UploadService, UploadServiceConfig, UriSchemePipe, UrlModule };
//# sourceMappingURL=cleavelandprice-ngx-lib.mjs.map
